#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeService.h"   // class implemented
#include "WarCollector.h"
#include "WarIfServer.h"
#include "WmsNodeManagement.h"
#include "WmsNodeServersFolder.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////

// {B8480B39-40C6-433c-A625-F4BDD89F7118}
const GUID WmsNodeService::thisGuid = 
{ 0xb8480b39, 0x40c6, 0x433c, { 0xa6, 0x25, 0xf4, 0xbd, 0xd8, 0x9f, 0x71, 0x18 } };


WmsNodeService::WmsNodeService(war_if_server_ptr_t& rSvrPtr)
: mServicePtr(rSvrPtr)
{
}

WmsNodeService::~WmsNodeService()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================

HRESULT WmsNodeService::OnExpand(IConsoleNameSpace *pConsoleNameSpace, 
                                 IConsole *pConsole, 
                                 HSCOPEITEM parent)
{
    if (GetHandle() == NULL) 
        SetHandle((HANDLE)parent);

    if (!bExpanded) 
    {
        // create the child nodes, then expand them
        for(int i = 0; i < 2; i++)
        {
            CDelegationBase *pnew_node;
            SCOPEDATAITEM sdi;

            switch(i)
            {
            case 0:
                pnew_node = new WmsNodeManagement(mServicePtr);
                break;
            case 1:
                pnew_node = new WmsNodeServersFolder(mServicePtr);
                break;
            }

            ZeroMemory(&sdi, sizeof(SCOPEDATAITEM));
            sdi.mask = SDI_STR|   // Displayname is valid
                SDI_PARAM     |   // lParam is valid
                SDI_IMAGE     |   // nImage is valid
                SDI_OPENIMAGE |   // nOpenImage is valid
                SDI_PARENT;
            
            sdi.relativeID  = (HSCOPEITEM)parent;
            sdi.nImage      = pnew_node->GetBitmapIndex();
            sdi.nOpenImage  = pnew_node->GetBitmapIndex();
            sdi.displayname = MMC_CALLBACK;
            sdi.lParam      = (LPARAM)pnew_node;     // The cookie
            
            HRESULT hr = pConsoleNameSpace->InsertItem(&sdi);
            _ASSERT( SUCCEEDED(hr) );
            
            pnew_node->SetHandle((HANDLE)sdi.ID);
        }
    }

    return S_OK;
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeService::GetBitmapIndex()
{
    return NICON_SERVICE;
}

const _TCHAR *WmsNodeService::GetDisplayName(int nCol)
{    
   return mServicePtr->GetName();
}

const GUID & WmsNodeService::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

