/** 
*/

#ifndef WAR_OPTION_LIST_H
#define WAR_OPTION_LIST_H

/* SYSTEM INCLUDES */

#ifndef WAR_SET_INCLUDED
#   define WAR_SET_INCLUDED
#   include <set>
#endif


/* PROJECT INCLUDES */

#ifndef WAR_OPTION_H
#   include "WarOption.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarOptionList : public std::set<war_option_ptr_t>
{
public:
    typedef std::set<war_option_ptr_t> type_t;
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarOptionList(void);
    /**
    * Copy constructor.
    *
    * @param from The value to copy to this object.
    */
    WarOptionList(const WarOptionList& from);
    
    /**
    * Destructor.
    */
    ~WarOptionList(void)
    {
    }
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarOptionList& operator = (const WarOptionList& from);

    WarOptionList& operator += (const WarOptionList& from);

    // OPERATIONS                       
    // ACCESS

    const war_option_ptr_t GetOption(const std::string& name) const;

    template <class typeT>
    void SetOption(war_ccstr_t optName, 
        const typeT& optValue)
    {
        WarPtrWrapper<WarOption> my_opt 
            = new WarOption(optName);

        iterator P = find(my_opt);
        if (P != end())
            (*P)->SetValue(optValue);
        else
        {
            WarCollector<char> buf;
            buf << optValue;
            insert(new WarOption(optName, 
                buf.GetValue().c_str()));
        }
    }

    static WarOptionList& GetGlobalOptions();

    // INQUIRY

    bool HaveOption(war_ccstr_t name);
    
protected:
private:
    static WarOptionList *mspGlobalOptions;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_OPTION_LIST_H_ */

