/** 
*/

#ifndef WAR_OPTION_WIN32_H
#define WAR_OPTION_WIN32_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_OPTION_H
#   include "WarOption.h"
#endif

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarOptionWin32 : public WarOption
{
public:
    // LIFECYCLE
    WarOptionWin32(
        const WarWin32Registry& fatherKey,
        war_ccstr_t name, 
        war_ccstr_t value = NULL,
        war_ccstr_t defaultValue = NULL,
        war_ccstr_t description = NULL,
        WarOptionTypeE type = OT_STRING)
        throw(WarException);
    
    // OPERATORS  
    // OPERATIONS                       
    // ACCESS
    
    virtual const std::string GetValue() const
        throw(WarException);
    
    virtual const int GetIntValue() const
        throw(WarException);
    
    virtual const std::string GetDefaultValue() const
        throw(WarException);
    
    virtual const int GetDefaultIntValue() const
        throw(WarException);
    
    virtual const std::string GetDescription() const
        throw(WarException);
    
    // INQUIRY
    
    virtual bool IsEmpty() const
        throw(WarException)
    {
        return GetValue().empty();
    }
    
protected:

    virtual void DoSetValue(const buffer_t& value)
        throw(WarException);

    virtual void DoSetDefaultValue(const buffer_t& value)
        throw(WarException);

    virtual void DoSetDescription(const buffer_t& value)
        throw(WarException);

private:

    WarWin32Registry mKey;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

WarWin32Registry& operator << (WarWin32Registry& o, 
                               const WarOptionList& value); 

WarWin32Registry& operator >> (WarWin32Registry& o, 
                               WarOptionList& value); 


#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_OPTION_WIN32_H_ */

