/** Base class for plugins
*/

#ifndef WAR_PLUGIN_H
#define WAR_PLUGIN_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarPlugin : public WarSmartPointer
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarPlugin() {}
    
    // OPERATORS
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY
protected:
    ~WarPlugin() {}

private:
};

/* NB: Must be called with args in bracets.
 * WAR_RUN_PLUGINS(FooClass, (arg))
 */

#define WAR_PLUGINS_BEGINPRC(type, args)\
try\
{\
    std::list<WarPtrWrapper<type> >& \
        ref = (std::list<WarPtrWrapper<type> >&)\
        GetPlugins(type::GetId());\
    for (std::list<WarPtrWrapper<type> >::iterator\
        P = ref.begin()\
        ; P != ref.end()\
        ; P++)\
    {\
        (*P)->OnProcess args ;\
    }\
}\
catch(WarException& e)\
{\
    switch(e.LocalError())\
    {\
    case WAR_ERR_PLUGIN_NONEXT:\
        break;\
    case WAR_ERR_PLUGIN_DONE:\
        return

#define WAR_PLUGIN_ENDPRC()\
    default:\
        throw(e);\
    }\
}

#define WAR_RUN_PLUGINS(type, args)\
    WAR_PLUGINS_BEGINPRC(type, args);\
    WAR_PLUGIN_ENDPRC()

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarPlugin> war_plugin_ptr_t;
typedef std::list<war_plugin_ptr_t> war_plugin_list_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_PLUGIN_H_ */

